%global maven_version 0.8.0.redhat-1
%global maven_repo_dir %{_javadir}/maven-repo
%global __jar_repack 0
%global geronimo_version 1.1.1-5
%global log4j_version 1.2.17-5
%global netty_version 4.0.17-3
%global slf4j_api_version 1.7.14-2
%global slf4j_log4j_version 1.7.14-2
%global proton_version 0.12.0

Name:           qpid-jms
Version:	0.8.0
Release:	6%{?dist}
License:	ASL 2.0
Summary:	Qpid JMS AMQP 1.0 Java Client
Group:		Development/Libraries
URL:		http://qpid.apache.org/components/jms/index.html
Source0:	apache-qpid-jms-%{maven_version}-bin.tar.gz 
Source1:	qpid-jms-parent-%{version}.redhat-1-scm-sources.zip 
Source1000:     example-settings.xml
Source1001:     README.md
Source2: qpid-jms-discovery-0.8.0.redhat-1.pom
Source3: qpid-jms-parent-0.8.0.redhat-1.pom
Source4: qpid-jms-docs-0.8.0.redhat-1.pom
Source5: qpid-jms-interop-tests-0.8.0.redhat-1.pom
Source6: apache-qpid-jms-0.8.0.redhat-1.pom
Source7: qpid-jms-activemq-tests-0.8.0.redhat-1.pom
Source8: qpid-jms-client-0.8.0.redhat-1.pom
Source9: qpid-jms-examples-0.8.0.redhat-1.pom

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch: 	noarch
BuildRequires:  zip
BuildRequires:  geronimo-jms_1.1_spec-amq-maven-repo >= %{geronimo_version}
BuildRequires:  log4j-amq-maven-repo >= %{log4j_version}
BuildRequires:  netty-all-amq-maven-repo = %{netty_version}%{?dist}
BuildRequires:  slf4j-api-amq-maven-repo >= %{slf4j_api_version}%{?dist}
BuildRequires:  slf4j-log4j-amq-maven-repo >= %{slf4j_log4j_version}%{?dist}
BuildRequires:  qpid-proton-java-maven-repo = %{proton_version}

%description
Qpid JMS is a complete AMQP 1.0 Java Message Service 1.1 client built using Qpid Proton.


%package client
Summary:        Qpid JMS AMQP 1.0 Java - client
Group:          Development/Java
Requires:       geronimo-jms_1.1_spec-amq >= %{geronimo_version}
Requires:       log4j-amq >= %{log4j_version}
Requires:       netty-all-amq = %{netty_version}%{?dist}
Requires:       slf4j-api-amq >= %{slf4j_api_version}%{?dist}
Requires:       slf4j-log4j-amq >= %{slf4j_log4j_version}%{?dist}
Requires:       qpid-proton-java = %{proton_version}

%description client
Qpid JMS AMQP 1.0 Java Client Library


%package client-maven-repo
Summary:        Qpid JMS AMQP 1.0 Java - maven repo
Group:          Development/Java
Requires:       qpid-jms-client = %{version}-%{release}
Requires:       geronimo-jms_1.1_spec-amq-maven-repo >= %{geronimo_version}
Requires:       log4j-amq-maven-repo >= %{log4j_version}
Requires:       netty-all-amq-maven-repo = %{netty_version}%{?dist}
Requires:       slf4j-api-amq-maven-repo >= %{slf4j_api_version}%{?dist}
Requires:       slf4j-log4j-amq-maven-repo >= %{slf4j_log4j_version}%{?dist}
Requires:       qpid-proton-java-maven-repo = %{proton_version}

%description client-maven-repo
Qpid JMS AMQP 1.0 Java Client Library maven repo


%package client-zip
Summary:        Qpid JMS AMQP 1.0 Java - maven repo
Group:          Development/Java

%description client-zip
Qpid JMS AMQP 1.0 Java Client Library zip file


%package client-examples
Summary:        Qpid JMS AMQP 1.0 Java - examples
Group:          Development/Java

Requires:       qpid-jms-client = %{version}-%{release}
Requires:       qpid-jms-client-maven-repo = %{version}-%{release}
Requires:       geronimo-jms_1.1_spec-amq-maven-repo >= %{geronimo_version}
Requires:       log4j-amq-maven-repo >= %{log4j_version}
Requires:       netty-all-amq-maven-repo = %{netty_version}%{?dist}
Requires:       slf4j-api-amq-maven-repo >= %{slf4j_api_version}%{?dist}
Requires:       slf4j-log4j-amq-maven-repo >= %{slf4j_log4j_version}%{?dist}
Requires:       qpid-proton-java-maven-repo = %{proton_version}

%description client-examples
Qpid JMS AMQP 1.0 Java Client Examples

%package client-docs
Summary:	Qpid JMS AMQP 1.0 Java - docs
Group:		Development/Java

%description client-docs
Qpid JMS AMQP 1.0 Java Client Docs


%prep
%setup -q -n apache-qpid-jms-%{maven_version}

%build

%install
rm -rf %{buildroot}

function maven_checksums() {
  local FILEPATH=$1
  local DESTFILE=$2
  if [ -z "$DESTFILE" ]; then
    DESTFILE=$FILEPATH
  fi
  md5sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.md5
  sha1sum $FILEPATH | cut -d' ' -f1 > $DESTFILE.sha1
}

function populate_maven_repo() {
  local POMPATH=$1
  local POMDIR=${POMPATH%/*}
  local POMFILE=${POMPATH##*/}
  local JARFILE=${POMFILE%.pom}.jar
  %{__mkdir_p} %{buildroot}%{maven_repo_dir}/$POMDIR
  %{__install} -pm 644 %{_sourcedir}/$POMFILE \
                       %{buildroot}%{maven_repo_dir}/$POMDIR
  maven_checksums %{buildroot}%{maven_repo_dir}/$POMDIR/$POMFILE
  local VERSION=${POMDIR##*/}
  local PARENTDIR=${POMDIR%/*}
  local ARTIFACTID=${PARENTDIR##*/}
  local GROUPPATH=${PARENTDIR%/*}
  local GROUPID=${GROUPPATH//\//.}
  cat > %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml <<EOF
<metadata>
  <groupId>$GROUPID</groupId>
  <artifactId>$ARTIFACTID</artifactId>
  <versioning>
    <release>$VERSION</release>
    <versions>
      <version>$VERSION</version>
    </versions>
    <lastUpdated>$(date +%%Y%%m%%d%%H%%M%%S)</lastUpdated>
  </versioning>
</metadata>
EOF
  maven_checksums %{buildroot}%{maven_repo_dir}/$PARENTDIR/maven-metadata.xml
  if [ -f %{buildroot}%{_javadir}/%{name}-%{version}/$JARFILE ]; then
    ln -s %{_javadir}/%{name}-%{version}/$JARFILE \
          %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
    maven_checksums %{buildroot}%{_javadir}/%{name}-%{version}/$JARFILE \
      %{buildroot}%{maven_repo_dir}/$POMDIR/$JARFILE
  fi
}

%{__install} -dm 755 %{buildroot}%{_javadir}
%{__install} -dm 755 %{buildroot}%{_javadir}/%{name}-%{version}

#for jar in lib/*.jar; do
#  %{__install} -pm 644 "$jar" %{buildroot}%{_javadir}/%{name}-%{version}
#done

%{__install} -pm 644 lib/qpid-jms*.jar %{buildroot}%{_javadir}/%{name}-%{version}
%{__install} -pm 644 lib/netty*.jar %{buildroot}%{_javadir}/%{name}-%{version}

%{__install} -dm 755 %{buildroot}%{_docdir}/%{name}-%{version}
%{__install} -pm 644 LICENSE %{buildroot}%{_docdir}/%{name}-%{version}
%{__install} -pm 644 NOTICE %{buildroot}%{_docdir}/%{name}-%{version}
%{__install} -pm 644 README.txt %{buildroot}%{_docdir}/%{name}-%{version}

# examples
cp -a examples %{buildroot}%{_docdir}/%{name}-%{version}/examples

# docs
cp -a docs %{buildroot}%{_docdir}/%{name}-%{version}/docs

#zip
cp -a .  %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/


populate_maven_repo org/apache/qpid/qpid-jms-discovery/0.8.0.redhat-1/qpid-jms-discovery-0.8.0.redhat-1.pom
populate_maven_repo org/apache/qpid/qpid-jms-parent/0.8.0.redhat-1/qpid-jms-parent-0.8.0.redhat-1.pom
populate_maven_repo org/apache/qpid/qpid-jms-client/0.8.0.redhat-1/qpid-jms-client-0.8.0.redhat-1.pom

cp -LRp %{maven_repo_dir} %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/
cp -PRp %{buildroot}%{maven_repo_dir}/org/apache/qpid/qpid-jms-client %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/
cp -PRp %{buildroot}%{maven_repo_dir}/org/apache/qpid/qpid-jms-parent %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/
cp -PRp %{buildroot}%{maven_repo_dir}/org/apache/qpid/qpid-jms-discovery %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/

rm %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/qpid-jms-client/%{maven_version}/qpid-jms-client-%{maven_version}.jar
rm %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/qpid-jms-discovery/%{maven_version}/qpid-jms-discovery-%{maven_version}.jar

cp -p %{buildroot}%{_javadir}/%{name}-%{version}/qpid-jms-client-%{maven_version}.jar %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/qpid-jms-client/%{maven_version}/
cp -p %{buildroot}%{_javadir}/%{name}-%{version}/qpid-jms-discovery-%{maven_version}.jar %{buildroot}%{_javadir}/apache-qpid-jms-%{maven_version}/maven-repo/org/apache/qpid/qpid-jms-discovery/%{maven_version}/

cd %{buildroot}%{_javadir}
zip -r apache-qpid-jms-%{maven_version}-bin.zip apache-qpid-jms-%{maven_version}
mkdir -p jboss-amq-qpid-jms-%{maven_version}-maven-repository/maven-repository
cp -PRp apache-qpid-jms-%{maven_version}/maven-repo/* jboss-amq-qpid-jms-%{maven_version}-maven-repository/maven-repository/
zip -r jboss-amq-qpid-jms-%{maven_version}-maven-repository.zip jboss-amq-qpid-jms-%{maven_version}-maven-repository 
cp -Pp %{_sourcedir}/example-settings.xml jboss-amq-qpid-jms-%{maven_version}-maven-repository/
cp -Pp %{_sourcedir}/README.md jboss-amq-qpid-jms-%{maven_version}-maven-repository/
rm -fr apache-qpid-jms-%{maven_version}
rm -fr jboss-amq-qpid-jms-%{maven_version}-maven-repository

%clean
rm -rf %{buildroot}

%files client
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}-%{version}
%{_javadir}/%{name}-%{version}/*.jar
%{_docdir}/%{name}-%{version}/LICENSE
%{_docdir}/%{name}-%{version}/NOTICE
%{_docdir}/%{name}-%{version}/README.txt

%files client-maven-repo
%defattr(-,root,root,-)
%{maven_repo_dir}

%files client-examples
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}/examples/

%files client-docs
%defattr(-,root,root,-)
%{_docdir}/%{name}-%{version}/docs/

%files client-zip
%defattr(-,root,root,-)
%{_javadir}/apache-qpid-jms-%{maven_version}-bin.zip
%{_javadir}/jboss-amq-qpid-jms-%{maven_version}-maven-repository.zip


%changelog
* Fri Jul 29 2016 Irina Boverman <iboverma@redhat.com> - 0.8.0-6
- Updated slf4j* dependency

* Wed Jul 27 2016 Irina Boverman <iboverma@redhat.com> - 0.8.0-5
- Corrected dependency

* Tue Jul 26 2016 Irina Boverman <iboverma@redhat.com> - 0.8.0-4
- Rebuilt against required versions of packages

* Fri Jul 22 2016 Irina Boverman <iboverma@redhat.com> - 0.8.0-3
- Added netty to maven-repo package
- Updated dependencies to redhat versions

* Mon Jun 20 2016 Irina Boverman <iboverma@redhat.com> - 0.8.0-2
- Resolved ENTMQCL-394 

* Tue Feb 23 2016 Irina Boverman <iboverma@redhat.com> - 0.8.0-1
- Rebased to 0.8.0

* Wed Sep  9 2015 Irina Boverman <iboverma@redhat.com> - 0.5.0-2
- Resolved ENTMQCL-15

* Mon Aug 31 2015 Irina Boverman <iboverma@redhat.com> - 0.5.0-1
- Rebased to 0.5.0

* Thu Aug 20 2015 Irina Boverman <iboverma@redhat.com> - 0.4.0-1
- Rebased to 0.4.0

* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 0.3.0-3
- Updated dependencies

* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 0.3.0-2
- Corrected dependencies

* Tue Jul 21 2015 Irina Boverman <iboverma@redhat.com> - 0.3.0-1
- Added zip file 
- Updated dependencies
- Rebased to 0.3.0

* Tue May 26 2015 Irina Boverman <iboverma@redhat.com> - 0.2.0-2
- Updated dependencies

* Thu May 21 2015 Irina Boverman <iboverma@redhat.com> - 0.2.0-1
- Rebased to 0.2.0

* Fri May  1 2015 Mike Bonnet <mikeb@redhat.com> - 0.1.0-2
- Add maven-repo subpackage

* Thu Apr 10 2015 Irina Boverman <iboverma@redhat.com> - 0.1.0-1
- Initial creation of wrapper rpm
